import javax.microedition.lcdui.Graphics;

public final class ChrCoin extends Chr {
	public static final int[] COIN_SIZE = new int[]{mcrITOF(4), mcrITOF(4), mcrITOF(5), mcrITOF(5), mcrITOF(6),
			mcrITOF(6), mcrITOF(7), mcrITOF(7), mcrITOF(8)};
	public static final int[] COIN_VALUE = new int[]{10, 50, 100, 200, 500, 1000, 2000, 5000, 10000};
	public static ChrCoin[] chr = new ChrCoin[30];

	public static void clearAll() {
		for (int i = 29; i >= 0; --i) {
			chr[i].needCheck = false;
		}

	}

	public static void create(int type, int worldX, int worldY, int worldVX, int worldVY) {
		if (type != 0) {
			for (int i = 29; i >= 0; --i) {
				if (!chr[i].needCheck) {
					chr[i].reinit(type - 1, worldX, worldY, worldVX, worldVY);
					break;
				}
			}

		}
	}

	public static void actAll() {
		for (int i = 29; i >= 0; --i) {
			if (chr[i].needCheck) {
				chr[i].act();
			}
		}

	}

	public static void drawAll() {
		for (int i = 29; i >= 0; --i) {
			if (chr[i].needCheck) {
				chr[i].draw();
			}
		}

	}

	public static void isHitAll() {
		for (int i = 29; i >= 0; --i) {
			if (chrOpaOpa.isHit(chr[i])) {
				chr[i].needCheck = false;
				chrOpaOpa.addMoney(COIN_VALUE[chr[i].money]);
				ChrExplode.create(2, chr[i].worldX, chr[i].worldY);
			}
		}

	}

	public static void drawAllCollision(Graphics gc, int color) {
		for (int i = 29; i >= 0; --i) {
			chr[i].drawCollision(gc, color);
		}

	}

	private void reinit(int type, int worldX, int worldY, int worldVX, int worldVY) {
		this.worldX = worldX;
		this.worldY = worldY;
		this.worldVX = worldVX;
		this.worldVY = worldVY;
		this.screenX = map.getScreenX(this.worldX);
		this.screenY = map.getScreenY(this.worldY);
		this.collisionWidth = COIN_SIZE[type];
		this.collisionHeight = COIN_SIZE[type];
		this.setCollision();
		this.money = type;
		this.isWorldView = true;
		this.count = 0;
		this.needCheck = true;
		this.type = type;
	}

	public void act() {
		++numActive;
		if (this.count++ >= 90) {
			this.needCheck = false;
		}

		this.worldVY += mcrITOF(6) >> 2;
		this.worldX += this.worldVX;
		this.worldY += this.worldVY;
		if (this.worldY + this.collisionHeight >= mcrITOF(192)) {
			this.worldY = mcrITOF(192) - this.collisionHeight;
			this.worldVX >>= 1;
			this.worldVY = -(this.worldVY * 7 >> 3);
			if (this.worldVY < mcrITOF(-16)) {
				this.worldVY = mcrITOF(-16);
			}
		}

		this.screenX = map.getScreenX(this.worldX);
		this.screenY = map.getScreenY(this.worldY);
		this.setCollision();
	}

	public void draw() {
		this.drawRegion(FantasyZone.imgSystem[15], 18 * (this.count & 3), 18 * this.type, 18, 18, 0,
				mcrFTOI(this.screenX), mcrFTOI(this.screenY), 3);
	}

	static {
		for (int i = 29; i >= 0; --i) {
			chr[i] = new ChrCoin();
		}

	}
}