import javax.microedition.lcdui.Image;

public final class ChrOpaOpa extends Chr {
	public static final int GU_TRANS_MIRROR = 2;
	public static final int[] ANM_OPAOPA = new int[]{1, 2, 3, 2};
	public static final int[][] ANM_ENGINE = new int[][]{{5, 6, 7, 6}, {8, 9, 10, 9}, {11, 12, 13}, {14, 15, 16},
			{17, 18}};
	public static final int[] SPD_OPAOPA = new int[]{mcrITOF(6), mcrITOF(8), mcrITOF(12), mcrITOF(15), mcrITOF(22)};
	public static final int[] TRANS_SHOPITEM_TO_ITEM = new int[]{1, 2, 3, 4, 6, 7, 8, 10, 11, 12, 13};
	public static final int[][] TRANS_EQUIPITEM_TO_SHOPITEM = new int[][]{{-1, 0, 1, 2, 3}, {-1, 4, 5, 6},
			{-1, 7, 8, 9, 10}};
	public static Image[] imgOpaOpa;
	public boolean isEarth;
	public boolean isMove;
	public int shipNum;
	public int[] itemNum = new int[12];
	public int[] equip = new int[3];
	public int anmOpaOpa;
	public int cntAnmOpaOpa;
	public int anmEngine;
	public int cntAnmEngine;
	public int hpMax;
	public int countNoDamage;

	public void init(int hpMax) {
		this.hpMax = hpMax;
		this.shipNum = 2;
		this.money = 0;
	}

	public void reinit(boolean isStart, boolean isDead) {
		if (isDead) {
			--this.shipNum;
		}

		this.isEarth = false;
		this.isMove = false;
		this.needCheck = true;
		this.hp = this.hpMax;
		this.countNoDamage = 0;
		this.worldX = 0;
		this.worldY = isStart ? mcrITOF(-4) : mcrITOF(96);
		this.dir = 0;
		this.isWorldView = true;
		if (isStart || isDead) {
			for (int i = this.itemNum.length - 1; i >= 0; --i) {
				this.itemNum[i] = 0;
			}

			this.equip[1] = 0;
			this.equip[2] = 0;
			this.equip[0] = 0;
		}

		this.collisionWidth = mcrITOF(8);
		this.collisionHeight = mcrITOF(5);
		map.setView(this, false);
		this.screenX = map.getScreenX(this.worldX);
		this.screenY = map.getScreenY(this.worldY);
		this.setCollision();
	}

	public void setPosition(int x, int y) {
		this.screenX = x << 12;
		this.screenY = mcrITOF(y);
	}

	public void actFirst(int count) {
		this.worldX += mcrITOF(14) / 3;
		this.worldY += mcrITOF(4) / 3;
		map.cameraX += mcrITOF(14) / 3;
		this.screenX = map.getScreenX(this.worldX);
		this.screenY = map.getScreenY(this.worldY);
		this.cntAnmEngine += 2;
		this.anmEngine = ANM_ENGINE[this.equip[0]][((this.cntAnmEngine & Integer.MAX_VALUE) >> 1)
				% ANM_ENGINE[this.equip[0]].length];
		this.setCollision();
	}

	public void act(int key) {
		if (this.isWorldView) {
			this.worldVX = this.worldX;
			this.worldVY = this.worldY;
			this.isMove = false;
			if ((key & 4100) != 0) {
				this.worldY -= SPD_OPAOPA[this.equip[0]];
			} else if ((key & '脀') != 0) {
				this.worldY += SPD_OPAOPA[this.equip[0]];
			}

			if ((key & 8208) != 0) {
				this.isMove = true;
				this.worldX = (mcrITOF(2048) + this.worldX - SPD_OPAOPA[this.equip[0]]) % mcrITOF(2048);
				this.dir = 2;
				++this.cntAnmOpaOpa;
				++this.cntAnmEngine;
			} else if ((key & 16448) != 0) {
				this.isMove = true;
				this.worldX = (this.worldX + SPD_OPAOPA[this.equip[0]]) % mcrITOF(2048);
				this.dir = 0;
				++this.cntAnmOpaOpa;
				++this.cntAnmEngine;
			} else if (!this.isEarth) {
				this.worldX = (mcrITOF(2048) + this.worldX + DIR_X[this.dir] * mcrITOF(2)) % mcrITOF(2048);
			}

			if (this.worldY >= mcrITOF(180)) {
				this.worldY = mcrITOF(180);
				this.isEarth = true;
			} else {
				this.isEarth = false;
				if (this.worldY <= mcrITOF(6)) {
					this.worldY = mcrITOF(6);
				}
			}

			map.setView(this, false);
			this.screenX = map.getScreenX(this.worldX);
			this.screenY = map.getScreenY(this.worldY);
			this.worldVX = this.screenX - map.getScreenX(this.worldVX);
			this.worldVY = this.screenY - map.getScreenY(this.worldVY);
		} else {
			this.worldVX = this.screenX;
			this.worldVY = this.screenY;
			map.setView(this, true);
			if (!map.isLastBoss) {
				if ((key & 4100) != 0) {
					this.screenY -= SPD_OPAOPA[this.equip[0]];
				} else if ((key & '脀') != 0) {
					this.screenY += SPD_OPAOPA[this.equip[0]];
				}

				if ((key & 8208) != 0) {
					this.screenX -= SPD_OPAOPA[this.equip[0]];
					this.dir = 2;
				} else if ((key & 16448) != 0) {
					this.screenX += SPD_OPAOPA[this.equip[0]];
					this.dir = 0;
				}
			} else {
				if (this.screenY > mcrITOF(180)) {
					this.screenY = mcrITOF(180);
				}

				for (int i = mcrFTOI(SPD_OPAOPA[this.equip[0]]) - 1; i >= 0; --i) {
					if ((key & 4100) != 0) {
						this.screenY -= mcrITOF(1);
						if (ChrBoss.ALIEN_WAY[mcrFTOI(this.screenY) / 8 * 31 + mcrFTOI(this.screenX) / 8]) {
							this.screenY += mcrITOF(1);
						}
					} else if ((key & '脀') != 0) {
						this.screenY += mcrITOF(1);
						if (ChrBoss.ALIEN_WAY[mcrFTOI(this.screenY + mcrITOF(7)) / 8 * 31
								+ mcrFTOI(this.screenX) / 8]) {
							this.screenY -= mcrITOF(1);
						}
					}

					if ((key & 8208) != 0) {
						this.screenX -= mcrITOF(1);
						this.dir = 2;
						if (ChrBoss.ALIEN_WAY[mcrFTOI(this.screenY) / 8 * 31 + mcrFTOI(this.screenX) / 8]) {
							this.screenX += mcrITOF(1);
						}
					} else if ((key & 16448) != 0) {
						this.screenX += mcrITOF(1);
						this.dir = 0;
						if (ChrBoss.ALIEN_WAY[mcrFTOI(this.screenY) / 8 * 31
								+ mcrFTOI(this.screenX + mcrITOF(7)) / 8]) {
							this.screenX -= mcrITOF(1);
						}
					}
				}

				if (this.screenY > mcrITOF(180)
						&& !ChrBoss.ALIEN_WAY[(mcrFTOI(this.screenY) / 8 - 1) * 31 + mcrFTOI(this.screenX) / 8]) {
					this.screenY = mcrITOF(180);
				}

				if (this.screenX >= mcrITOF(220)) {
					this.screenX = mcrITOF(220);
				}

				if (this.screenY >= mcrITOF(180)) {
					this.screenY = mcrITOF(180);
				}
			}

			if (map.stage < 5) {
				this.dir = 0;
			}

			++this.cntAnmOpaOpa;
			++this.cntAnmEngine;
			if (map.isLastBoss) {
				this.isEarth = false;
			} else {
				if (this.screenX >= mcrITOF(220)) {
					this.screenX = mcrITOF(220);
				}

				if (this.screenX <= mcrITOF(20)) {
					this.screenX = mcrITOF(20);
				}

				if (this.screenY >= mcrITOF(180)) {
					this.screenY = mcrITOF(180);
					this.isEarth = true;
				} else {
					this.isEarth = false;
					if (this.screenY <= mcrITOF(6)) {
						this.screenY = mcrITOF(6);
					}
				}
			}

			this.worldX = map.getWorldX(this.screenX);
			this.worldY = map.getWorldY(this.screenY);
			this.worldVX = this.screenX - this.worldVX;
			this.worldVY = this.screenY - this.worldVX;
		}

		++this.cntAnmEngine;
		if (this.isEarth) {
			this.anmOpaOpa = ANM_OPAOPA[((this.cntAnmOpaOpa & Integer.MAX_VALUE) >> 1) % ANM_OPAOPA.length];
			this.anmEngine = this.equip[0];
		} else {
			this.anmOpaOpa = 0;
			this.anmEngine = ANM_ENGINE[this.equip[0]][((this.cntAnmEngine & Integer.MAX_VALUE) >> 1)
					% ANM_ENGINE[this.equip[0]].length];
		}

		this.setCollision();
		if (!map.isRoundUp) {
			this.createShot();
			if ((key & 68640) != 0) {
				this.createBomb();
			}
		}

		if (!this.needCheck) {
			this.needCheck = --this.countNoDamage == 0;
		}

	}

	public void act() {
	}

	private void createShot() {
		switch (this.equip[1]) {
			case 0 :
				if (map.stageCount % 3 == 0) {
					ChrOpaShot.create(0, this.worldX, this.worldY, this.dir, 0);
					ChrOpaShot.create(0, this.worldX, this.worldY, this.dir, 1);
				}
				break;
			case 1 :
				ChrOpaShot.create(1, this.worldX, this.worldY, this.dir, 0);
				this.addItem(TRANS_EQUIPITEM_TO_SHOPITEM[1][1], -1);
				break;
			case 2 :
				if (map.stageCount % 3 == 0) {
					ChrOpaShot.create(2, this.worldX, this.worldY, this.dir, 0);
				}

				this.addItem(TRANS_EQUIPITEM_TO_SHOPITEM[1][2], -1);
				break;
			case 3 :
				if (map.stageCount % 3 == 0) {
					for (int i = 6; i >= 0; --i) {
						ChrOpaShot.create(3, this.worldX, this.worldY, this.dir, i);
					}
				}

				this.addItem(TRANS_EQUIPITEM_TO_SHOPITEM[1][3], -1);
		}

	}

	private void createBomb() {
		if (ChrOpaBomb.create(this.equip[2], this.worldX, this.worldY, this.dir)) {
			if (this.equip[2] == 3) {
				;
			}

			if (mcrIsBetween(2, this.equip[2], 4)) {
				this.addItem(TRANS_EQUIPITEM_TO_SHOPITEM[2][this.equip[2]], -1);
			}
		}

	}

	public void draw() {
		if ((this.countNoDamage & 2) == 0) {
			int transform = this.dir == 0 ? 0 : 2;
			int x = mcrFTOI(this.screenX);
			int y = mcrFTOI(this.screenY);
			this.drawRegion(imgOpaOpa[0], 0, this.anmOpaOpa * 16 + (this.anmOpaOpa == 0 ? 1 : 2), 17, 16, transform,
					0 + x, 2 + y, 3);
			this.drawRegion(imgOpaOpa[1], 0, 10 * this.anmEngine, 27, 10, transform, -15 * DIR_X[this.dir] + x, 1 + y,
					3);
		}
	}

	public void draw(int screenX, int screenY) {
		this.setPosition(screenX, screenY);
		this.draw();
	}

	public int addScore(int add) {
		FantasyZone.repaintScore = true;
		this.score += add;
		if (this.score > 999999999) {
			this.score = 999999999;
		}

		return this.score;
	}

	public int addMoney(int add) {
		FantasyZone.repaintMoney = true;
		this.money += add;
		if (this.money > 999999999) {
			this.money = 999999999;
		}

		return this.money;
	}

	public int addItem(int type, int add) {
		FantasyZone.repaintItem = true;
		this.itemNum[type] += add;
		if (this.itemNum[type] <= 0) {
			this.itemNum[type] = 0;
			if (mcrIsBetween(4, type, 6)) {
				this.equip[1] = 0;
				if (this.equip[2] == 0 || this.equip[2] == 1) {
					ChrBalloon.create(false, chrOpaOpa.dir);
				}
			} else {
				this.equip[2] = 0;
				if (this.equip[1] == 0) {
					ChrBalloon.create(false, chrOpaOpa.dir);
				}
			}
		}

		return this.itemNum[type];
	}

	public boolean damage() {
		if (--this.hp == 0) {
			return true;
		} else {
			if (map.isLastBoss) {
				ChrBoss.reinitAlien(true);
			} else {
				this.countNoDamage = 24;
				this.needCheck = false;
			}

			return false;
		}
	}
}