import javax.microedition.lcdui.Graphics;
import javax.microedition.lcdui.Image;

public final class Shop {
	public int[] item = new int[3];
	public static final int GRAPHICS_HCENTER = 1;
	public static final int GRAPHICS_VCENTER = 2;
	public static final int GRAPHICS_LEFT = 4;
	public static final int GRAPHICS_RIGHT = 8;
	public static final int GRAPHICS_TOP = 16;
	public static final int GRAPHICS_BOTTOM = 32;
	public static final int VIEW_WIDTH = 176;
	public static final int VIEW_HEIGHT = 160;
	public static final int GU_TRANS_NONE = 0;
	public static final int[] PRICE_FIRST = new int[12];
	public static final int[] ITEM_PRICE_UP = new int[11];
	public static final int[] SHIP_PRICE_UP = new int[3];
	public static final int[] ITEM_ADD = new int[11];
	public static final int[] ITEM_EQUAL_MAX = new int[11];
	public static final int[] ITEM_FRAME_COLOR = new int[12];
	private static Shop shop;
	public static Image[] img;
	private int viewX;
	private int cursolX;
	private int cursolY;
	private int time;
	private int[] price = new int[12];
	private boolean[] isSoldOut = new boolean[12];
	private int numBuyShip;
	private int select;
	private boolean canBuy;

	public static boolean mcrIsBetween(int a, int x, int b) {
		return a <= x && x <= b;
	}

	public static Shop getShop() {
		if (shop == null) {
			shop = new Shop();
		}

		return shop;
	}

	public void init() {
		for (int i = 11; i >= 0; --i) {
			this.price[i] = PRICE_FIRST[i];
		}

		this.numBuyShip = 0;
	}

	public void start(ChrOpaOpa chr) {
		this.viewX = 0;
		this.cursolX = 92;
		this.cursolY = 75;
		this.time = 30000;

		for (int i = ITEM_EQUAL_MAX.length - 1; i >= 0; --i) {
			this.isSoldOut[i] = chr.itemNum[i] >= ITEM_EQUAL_MAX[i];
		}

	}

	public boolean act(ChrOpaOpa chr, int key) {
		this.time -= 70;
		if (this.time <= 0) {
			return true;
		} else {
			if ((key & 16448) != 0 && this.cursolX < 510) {
				this.cursolX += 8;
			}

			if ((key & 8208) != 0 && this.cursolX > 8) {
				this.cursolX -= 8;
			}

			if (this.cursolX - this.viewX < 40 && this.viewX > 0) {
				this.viewX -= 8;
			}

			if (this.cursolX - this.viewX >= VIEW_HEIGHT && this.viewX < 510) {
				this.viewX += 8;
			}

			if ((key & '脀') != 0 && this.cursolY < 148) {
				this.cursolY += 6;
			}

			if ((key & 4100) != 0 && this.cursolY > 19) {
				this.cursolY -= 6;
			}

			this.select = 13;
			if (mcrIsBetween(76, this.cursolX - this.viewX, 108) && mcrIsBetween(71, this.cursolY, 79)) {
				this.select = 12;
			}

			for (int j = 1; j >= 0; --j) {
				for (int i = 5; i >= 0; --i) {
					if (mcrIsBetween(10 + 88 * i, this.cursolX, 10 + 88 * i + 76)
							&& mcrIsBetween(2 + 78 * j, this.cursolY, 2 + 78 * j + 67)) {
						this.select = i * 2 + j;
						i = 0;
						j = 0;
					}
				}
			}

			this.canBuy = false;
			if (this.select != 13 && this.select != 12) {
				this.canBuy = chr.money >= this.price[this.select] && !this.isSoldOut[this.select];
			}

			if ((key & 68640) != 0) {
				if (this.select == 12) {
					chr.equip[0] = this.item[0];
					chr.equip[1] = this.item[1];
					chr.equip[2] = this.item[2];

					for (int k = 0; k < 3; ++k) {
						this.item[k] = 0;
					}

					return true;
				}

				if (this.canBuy) {
					chr.addMoney(-this.price[this.select]);
					if (this.select == 11) {
						++chr.shipNum;
						this.price[this.select] = SHIP_PRICE_UP[this.numBuyShip];
						if (this.numBuyShip < SHIP_PRICE_UP.length - 1) {
							++this.numBuyShip;
						}
					} else {
						this.isSoldOut[this.select] = chr.addItem(this.select,
								ITEM_ADD[this.select]) >= ITEM_EQUAL_MAX[this.select];
						if (mcrIsBetween(0, this.select, 3)) {
							this.item[0] = this.select - 0 + 1;
						} else if (mcrIsBetween(4, this.select, 6)) {
							this.item[1] = this.select - 4 + 1;
						} else {
							this.item[2] = this.select - 7 + 1;
						}

						this.price[this.select] += ITEM_PRICE_UP[this.select];
					}

					this.canBuy = chr.money >= this.price[this.select] && !this.isSoldOut[this.select];
				}
			}

			return false;
		}
	}

	public void draw(Graphics gc) {
		gc.setColor(4379507);
		gc.fillRect(0, 0, 240, 200);

		for (int i = 11; i >= 0; --i) {
			int x = 10 + 88 * (i / 2) - this.viewX;
			int y = 2 + 78 * (i % 2);
			gc.setClip(x, y, 76, 67);
			gc.drawImage(img[2], x, y - ITEM_FRAME_COLOR[i] * 67, 20);
			if (i != this.select || (FantasyZone.commonCounter & 4) != 0 || !this.canBuy) {
				gc.setClip(x + 5, y + 6, 64, 24);
				gc.drawImage(img[3], x + 5, y + 6 - i * 24, 20);
			}

			FantasyZone.drawEnglish1(2, FantasyZone.getString(131 + i), x + 6, y + 37);
			FantasyZone.drawEnglish1(2, FantasyZone.getString(143 + i), x + 6, y + 45);
			FantasyZone.drawEnglish1(4, "$", x + 6, y + 53);
			FantasyZone.drawNumber1(4, this.price[i], x + 69, y + 53);
			if (this.isSoldOut[i]) {
				gc.drawImage(img[4], x + 17, y + 10, 20);
			}
		}

		FantasyZone.drawEnglish1(this.select == 12 ? 1 : 4, "EXIT", 76, 70);
		FantasyZone.drawEnglish(1, "" + this.time / 1000, 4, 95);
		gc.setClip(0, 0, 180, 180);
		gc.drawImage(img[0], this.cursolX - this.viewX, this.cursolY, 36);
	}
}