public class FantasyZoneDataMaker {
	public static final int[][] ENEMY_LOAD_DATA;
	public static final int[][] SHOP_DATA;

	public static final void main(String[] args) {
		byte[] buf;
		int i;
		int j;
		for (i = ENEMY_LOAD_DATA.length - 1; i >= 0; --i) {
			buf = new byte[ENEMY_LOAD_DATA[i].length << 1];

			for (j = ENEMY_LOAD_DATA[i].length - 1; j >= 0; --j) {
				buf[j * 2 + 0] = (byte) (ENEMY_LOAD_DATA[i][j] >> 8 & 255);
				buf[j * 2 + 1] = (byte) (ENEMY_LOAD_DATA[i][j] >> 0 & 255);
			}

			write("eload" + i + ".dat", buf);
		}

		write("enemy.dat", EnemyData.DATA);
		write("eshot.dat", EnemyShotData.DATA);

		for (i = 0; i < BossData.MONEY.length; ++i) {
			write("bmoney" + i + ".dat", BossData.MONEY[i]);
		}

		write("boss2.dat", BossData.BOSS2_TABLE);
		write("boss3.dat", BossData.BOSS3_TABLE);
		write("boss5.dat", BossData.BOSS5_TABLE);
		write("boss7.dat", BossData.BOSS7_TABLE);

		for (i = SHOP_DATA.length - 1; i >= 0; --i) {
			buf = new byte[SHOP_DATA[i].length << 1];

			for (j = SHOP_DATA[i].length - 1; j >= 0; --j) {
				buf[j * 2 + 0] = (byte) (SHOP_DATA[i][j] >> 8 & 255);
				buf[j * 2 + 1] = (byte) (SHOP_DATA[i][j] >> 0 & 255);
			}

			write("shop" + i + ".dat", buf);
		}

		write("star.dat", StarData.DATA);
	}

	public static final boolean write(String filename, byte[] buffer) {
		return true;
	}

	static {
		ENEMY_LOAD_DATA = new int[][]{EnemyLoadDataStage1.DATA, EnemyLoadDataStage2.DATA, EnemyLoadDataStage3.DATA,
				EnemyLoadDataStage4.DATA, EnemyLoadDataStage5.DATA, EnemyLoadDataStage6.DATA, EnemyLoadDataStage7.DATA};
		SHOP_DATA = new int[][]{ShopData.PRICE_FIRST, ShopData.ITEM_PRICE_UP, ShopData.SHIP_PRICE_UP, ShopData.ITEM_ADD,
				ShopData.ITEM_EQUAL_MAX, ShopData.ITEM_FRAME_COLOR};
	}
}