import javax.microedition.lcdui.Graphics;
import javax.microedition.lcdui.game.Sprite;

public class Sprite2D {
	private int width;
	private int height;
	private Sprite sprite;

	public Sprite2D(SpriteImage image, int x, int y, int width, int height) {
		this.sprite = new Sprite(image.image, width, height);
		this.width = image.getWidth();
		this.height = image.getHeight();
	}

	public void drawImage(Graphics gc, int x, int y, int anchor) {
		int var10000;
		if ((anchor & 4) != 0) {
			var10000 = x + (this.getMapWidth() >> 1);
		} else if ((anchor & 8) != 0) {
			var10000 = x - (this.getMapWidth() + 1 >> 1);
		}

		if ((anchor & 16) != 0) {
			var10000 = y + (this.getMapHeight() >> 1);
		} else if ((anchor & 32) != 0) {
			var10000 = y - (this.getMapHeight() + 1 >> 1);
		}

		this.sprite.paint(gc);
	}

	public void drawImage(Graphics gc, int x, int y) {
	}

	public int getMapWidth() {
		return this.width;
	}

	public int getMapHeight() {
		return this.height;
	}
}