import javax.microedition.lcdui.Image;

public class SpriteImage {
	public Image image;
	private int width;
	private int height;

	public SpriteImage(byte[] data) {
		this.width = (data[18] & 255) + ((data[19] & 255) << 8) + ((data[20] & 255) << 16) + ((data[21] & 255) << 24);
		this.height = (data[22] & 255) + ((data[23] & 255) << 8) + ((data[24] & 255) << 16) + ((data[25] & 255) << 24);
		this.image = Image.createImage(data, this.width, this.height);
	}

	public int getWidth() {
		return this.width;
	}

	public int getHeight() {
		return this.height;
	}
}